# Soble Lab Report

Name:
Name:

## Operative Unit

### Question 1: What is the nature of the VHDL process that describes the register bank? Its sensitivity list? Did the functional simulation validate the module? Justify


### Question 2: Give the results obtained


### Question 3: What type and quantification did you use for the internal signals? Justify.


### Question 4: How many processes are used and what are their natures? Sensitivity list? Did the functional simulation validate the module? Justify


### Question 5: Give the results obtained


### Question 6: Did the functional simulation validate the module? Justify


### Question 7: Give and comment on the results obtained

## Address Generator

### Question 8: Give the architecture you propose for the address generator

This diagram is to be completed in order to then complete the VHDL file `addGenUnit.vhd`. To do this, you can use the file `sobel-address-generator-student.drawio` available in the git repository, it is the file `docs/img/sobel-address-generator-student.drawio` with the tool [https://app.diagrams.net/](https://app.diagrams.net/). Then update the file `sobel-address-generator-student.png` by exporting the diagram `sobel-address-generator-student.drawio` previously updated.

![Address Generator](./img/sobel-address-generator-student.png)


### Question 9: Did the functional simulation validate the module? Justify


### Question 10: Give the results obtained

## Finite State Machine (FSM)

### Question 11: Complete the state machine diagram


This diagram is to be completed in order to then complete the VHDL file `automate.vhd`. To do this, you can use the file `sobel-FSM.drawio` available in the git repository, it is the file `docs/img/sobel-FSM.drawio` with the tool [https://app.diagrams.net/](https://app.diagrams.net/). Then update the file `sobel-FSM.png` by exporting the diagram `sobel-FSM.drawio` previously updated.

![FSM diagram](./img/sobel-FSM.png)


### Question 12: How many processes are used to describe the FSM, and what are their natures? Their sensitivity lists? Did the functional simulation validate the module? Justify


### Question 13: Give the results obtained

## Integration of the processor and prototyping

### Question 14: Did the functional simulation validate the module? Justify


### Question 15: Give and comment on the results obtained. What is the percentage of resources used by the Sobel processor compared to those available on the target Artix 7 FPGA `XC7A100T-CSG324-1`. Comment


### Question 16: Give and comment on the results obtained.


### Question 17: Is the prototyping and demonstration on the board conclusive?

## Performance analysis

### Question 18: Identify the maximum clock frequency achievable on this FPGA


### Question 19: How many clock cycles are needed to process a pixel?


### Question 20: How many clock cycles are needed to process a 396x396 definition image


### Question 21: How many 396x396 definition images can this processor process per second?
